// ==UserScript==
// @name           ePvP Ban Request AddOn
// @namespace      elitepvpers
// @include        /^https?:\/\/www\.elitepvpers\.com\/forum\/.*$/
// @author         Walter Sobchak
// @grant          none
// ==/UserScript==

(function (window) {
    function CreateButton(username, userlink, mode) {
        var btn, obj;

        if (mode == 'image') {
            btn = window.document.createElement('a');
            btn.href = '//elitepvpers.com/forum/newthread.php?do=newthread&f=301&br_code=true&br_username=' + encodeURIComponent(replaceEntities(username)) + '&br_userlink=' + userlink;
            btn.target = '_blank';
            btn.rel = 'nofollow';

            obj = window.document.createElement('img');
            obj.border = '0';
            obj.src = 'https://i.epvpimg.com/jPR4d.png';
            obj.title = 'Create a ban request';
            obj.alt = 'Create a ban request';
            obj.setAttribute('style', 'padding-right: 4px');
        }
        else if (mode == 'text') {
            obj = window.document.createElement('a');
            obj.href = '//elitepvpers.com/forum/newthread.php?do=newthread&f=301&br_code=true&br_username=' + encodeURIComponent(replaceEntities(username)) + '&br_userlink=' + userlink;
            obj.target = '_blank';
            obj.rel = 'nofollow';

            btn = window.document.createElement('li');
            btn.id = 'ban_request';
            btn.setAttribute('class', 'thead');

            obj.appendChild(window.document.createTextNode('Ban Request'));
        }

        btn.appendChild(obj);

        return btn;
    }

    function replaceEntities(username) {
        return username.replace(/&amp;/g, '&').replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&quot;/g, '"').replace(/&nbsp;/g, "\u00A0");
    }

    //Main
    if (window.document.location.href.indexOf('do=newthread&f=301') > -1) {
        var qsParm = new Array();

        function qs() {
            var query = window.location.search.substring(1);
            var parms = query.split('&');
            for (var i = 0; i < parms.length; i++) {
                var pos = parms[i].indexOf('=');
                if (pos > 0) {
                    var key = parms[i].substring(0, pos);
                    var val = parms[i].substring(pos + 1);
                    qsParm[key] = val;
                }
            }
        }

        qs();

        if (qsParm['br_code'] == 'true') {
            var subject = window.document.getElementsByName('subject');
            var textArea = window.document.getElementById('vB_Editor_001_textarea');

            subject[0].value = 'Ban request for ' + decodeURIComponent(qsParm['br_username']);
            textArea.value = 'User: [URL="' + qsParm['br_userlink'] + '"]' + decodeURIComponent(qsParm['br_username']) + '[/URL]\n' +
                'Reason: ' + '\n\n\n\n' +
                '[SIZE=1]Autogenerated by ePvP Ban Request AddOn.[/SIZE]';
        }
    }
    else if (window.document.location.href.indexOf('/forum/members/') > -1) {
        var userBar = window.document.getElementsByClassName('thead block_row block_title list_no_decoration floatcontainer');
        var usernameBox = window.document.getElementById('username_box');

        if (userBar) {
            userBar[0].insertBefore(CreateButton(usernameBox.getElementsByTagName('h1')[0].textContent.trim(), window.document.location.href, 'text'), window.document.getElementById('usercss_switch_link'));
        }
    }
    else {
        var postsDiv = window.document.getElementById('posts'), bottomBar, username, postTables, usernameTextWrapper,
            usernameText;

        if (postsDiv) {
            postTables = postsDiv.getElementsByTagName('table');
            if (postTables) {
                for (var i = 0; i < postTables.length; i++) {
                    if (postTables[i].id.indexOf('post') > -1) {
                        username = postTables[i].children[0].rows[1].cells[0].getElementsByClassName('bigusername');
                        bottomBar = postTables[i].children[0].rows[2].cells[1];

                        if ((username) && (bottomBar)) {
                            if (username[0].children.length > 0) {
                                usernameTextWrapper = username[0].children[0].children[0];
                                usernameText = usernameTextWrapper.children.length ? usernameTextWrapper.children[0].innerHTML : usernameTextWrapper.innerHTML;

                                bottomBar.insertBefore(CreateButton(usernameText, username[0].href, 'image'), bottomBar.children[0]);
                            }
                            else {
                                bottomBar.insertBefore(CreateButton(username[0].innerHTML.replace('<!-- google_ad_section_start(weight=ignore) -->', '').replace('<!-- google_ad_section_end -->', ''), username[0].href, 'image'), bottomBar.children[0]);
                            }

                        }
                    }
                }
            }
        }
    }
})(typeof unsafeWindow === 'undefined' ? window : unsafeWindow);